hdu 5067 Harry And Dig Machine(BestCoder Round #14)

Harry And Dig Machine

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)

Total Submission(s): 332    Accepted Submission(s): 104

Problem Description

As we all know, Harry Porter learns magic at Hogwarts School. However, learning magical knowledge alone is insufficient to become a great magician. Sometimes, Harry also has to gain knowledge from other certain subjects, such as language, mathematics, English,
and even algorithm.

Dumbledore, the headmaster of Hogwarts, is planning to construct a new teaching building in his school. The area he selects can be considered as an n*m grid, some (but no more than ten) cells of which might contain stones. We should remove the stones there
in order to save place for the teaching building. However, the stones might be useful, so we just move them to the top-left cell. Taking it into account that Harry learned how to operate dig machine in Lanxiang School several years ago, Dumbledore decides
to let him do this job and wants it done as quickly as possible. Harry needs one unit time to move his dig machine from one cell to the adjacent one. Yet skilled as he is, it takes no time for him to move stones into or out of the dig machine, which is big
enough to carry infinite stones. Given Harry and his dig machine at the top-left cell in the beginning, if he wants to optimize his work, what is the minimal time Harry needs to finish it?

Input

They are sever test cases, you should process to the end of file.

For each test case, there are two integers n and m.(1≤n,m≤50).

The next n line, each line contains m integer. The j-th number of ith line
a[i][j] means there are a[i][j] stones on the jth cell
of the ith line.( 0≤a[i][j]≤100 ,
and no more than 10 of a[i][j] will be positive integer).

Output

For each test case, just output one line that contains an integer indicate the minimal time that Harry can finish his job.

Sample Input

3 3
0 0 0
0 100 0
0 0 0
2 2
1 1
1 1

Sample Output

4
4

Source

BestCoder Round #14

知道是状压DP题,怎么都想不到思路,在最后写了个dfs交了一发,但写程序想到的剪枝忘写了,加上刚好结束,最后终测时TLE,加了剪枝就过了。由于就10个点,dfs复杂度为10!,再加个剪枝还是可以过的,状压DP的 还没会,先占个坑,会了再补上。

我的dfs代码:

#include <iostream>
#include <cstdio>
#include <cstring>
#include <algorithm>
using namespace std;
int a[100][100];
struct node
{
    int x;
    int y;
}p[100];
int bbs(int x)
{
    if(x<0)
    return -x;
    return x;
}
bool visit[100];
int t;
int ans;
void dfs(int v,int temp,node u)
{
   if(temp>ans)//剪枝
   return;
    if(v==0)//递归出口
    {
        temp=temp+u.x+u.y;
        if(temp<ans)
        ans=temp;
        return;
    }
    int yu;
    for(int i=0;i<t;i++)
    {
        if(visit[i]==false)
        {
           yu=temp+bbs(p[i].x-u.x)+bbs(p[i].y-u.y);
            visit[i]=true;
            dfs(v-1,yu,p[i]);
            visit[i]=false;
        }
    }
    return;
}
int main()
{
    int n,m;
    while(~scanf("%d%d",&n,&m))
    {
        int w;
        t=0;
        for(int i=0;i<n;i++)
        for(int j=0;j<m;j++)
        {
            scanf("%d",&w);
            if(j==0&&i==0)
            continue;
            if(w)
            {
                p[t].x=i;
                p[t++].y=j;
            }
        }
        memset(visit,false,sizeof(visit));
        ans=99999999;
        int temp=0;
        node u;
        u.x=0;
        u.y=0;
        dfs(t,temp,u);
        printf("%d\n",ans);
    }
    return 0;
}
时间: 2024-10-13 22:27:21

hdu 5067 Harry And Dig Machine(BestCoder Round #14)的相关文章

HDU 5067 Harry And Dig Machine(BestCoder Round #14)

Problem Description: As we all know, Harry Porter learns magic at Hogwarts School. However, learning magical knowledge alone is insufficient to become a great magician. Sometimes, Harry also has to gain knowledge from other certain subjects, such as

HDU 5067 Harry And Dig Machine(状压dp)

HDU 5067 Harry And Dig Machine 思路:由于点才10个,在加上一个起点,处理出每个点之间的曼哈顿距离,然后用状压dp搞,状态表示为: dp[i][s],表示在i位置,走过的点集合为s的最小代价 代码: #include <cstdio> #include <cstring> #include <cstdlib> #include <algorithm> using namespace std; const int N = 15;

hdu 5066 Harry And Physical Teacher(Bestcoder Round #14)

Harry And Physical Teacher Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others) Total Submission(s): 91    Accepted Submission(s): 68 Problem Description As we all know, Harry Porter learns magic at Hogwarts School. How

HDU - 5067 Harry And Dig Machine (bfs + 状态压缩)

题目大意:有一个n*m的网格,网格上面有k个地方有石头,现在要求从左上角出发,遍历所有有石头的地方,然后回到左上角,问最短距离是多少 解题思路:因为石头的总数小于等于10,所以可以进行压缩 设dp[i][j][state]表示在(i,j)位置,遍历的石头状态为state,走的最小距离,直接bfs即可 #include <cstdio> #include <cstring> #include <algorithm> #include <map> #includ

HDU 5067 Harry And Dig Machine(状压dp)

感觉这两天怎么老是遇到状压啊.... 数字20以下,首想状压啊... 不过这题犯抽忘记考虑没有石头的时候了啊. 简单的状压:表示状态为j时以第i的作为结束. PS:这题也在表扬大蓝翔的挖掘机技术啊.醉了啊... Harry And Dig Machine Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others) Total Submission(s): 468    Accepted S

HDU 5067 Harry And Dig Machine(状压DP)(TSP问题)

题目地址:pid=5067">HDU 5067 经典的TSP旅行商问题模型. 状压DP. 先分别预处理出来每两个石子堆的距离.然后将题目转化成10个城市每一个城市至少经过一次的最短时间模型.然后简单的状压DP就可以. 代码例如以下: #include <iostream> #include <cstdio> #include <string> #include <cstring> #include <stdlib.h> #incl

HDU 5067 Harry And Dig Machine

Harry And Dig Machine Time Limit: 1000ms Memory Limit: 32768KB This problem will be judged on HDU. Original ID: 506764-bit integer IO format: %I64d      Java class name: Main As we all know, Harry Porter learns magic at Hogwarts School. However, lear

hdu 5067 Harry And Dig Machine (状态压缩dp)

题目链接 bc上的一道题,刚开始想用这个方法做的,因为刚刚做了一个类似的题,但是想到这只是bc的第二题, 以为用bfs水一下就过去了,结果MLE了,因为bfs的队列里的状态太多了,耗内存太厉害. 题意: 从某一点出发,遍历网格上的一些点,每个点至少访问一次需要的最小时间是多少. 官方题解: 由于Harry的dig machine是无限大的,而装载石头和卸载石头是不费时间的,所以问题可以转化成:从某一点出发,遍历网格上的一些点,每个点至少访问一次需要的最小时间是多少.这就是经典的旅行商问题,考虑到

HDU 4982 Goffi and Squary Partition(BestCoder Round #6 1002)

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=4982 解析: 题意: 给你N和K,问能否将N拆分成K个互不相同的正整数,并且其中K-1个数的和为完全平方数     实际上,一拿到题目,我先想了下这里会不会存在负数或者0,后来经过几次华丽丽的WA之后发现,这题确实不用考虑到非正数.但是还是想吐槽一下,这个题目的意思也有点儿太不明晰了...     再说回题目来,我们枚举所有的完全平方数i*i,然后看能否将他拆成k-1个数,并且用不到n-i*i.所以